from Classifiers.Classifier import classifier
from sklearn.svm import SVC


class svmClassifier(classifier):



    def __init__(self, model= SVC, C=1.0, cache_size=200, class_weight=None, coef0=0.0,
                 decision_function_shape='ovr', degree=3, gamma='auto', kernel='linear',
                 max_iter=-1, probability=False, random_state=None, shrinking=True,
                 tol=0.001, verbose=False):


        super(svmClassifier, self).__init__()
        self.C = C
        self.cache_size = cache_size
        self.class_weight = class_weight
        self.coef0 = coef0
        self.decision_function_shape = decision_function_shape
        self.degree = degree
        self.gamma = gamma
        self.kernel = kernel
        self.max_iter = max_iter
        self.probability = probability
        self.random_state = random_state
        self.shrinking = shrinking
        self.tol = tol
        self.verbose = verbose
        self.model_name = "SVM"
        self.model = model(self.C, self.kernel, self.degree, self.gamma, self.coef0, self.probability,
                           self.shrinking, self.tol, self.cache_size, self.class_weight, self.verbose,
                           self.max_iter, self.decision_function_shape, self.random_state)

    def fit(self, train_matrix, train_label, sample_weight=None ):

        self.sample_weight = sample_weight
        return self.model.fit(train_matrix, train_label, self.sample_weight)

    def predict(self, test_matrix):

        return self.model.predict(test_matrix)

    def get_alg(self):

        return self.model_name

